#include <pspsdk.h>
#include <pspkernel.h>
#include <systemctrl.h>
#include <string.h>

PSP_MODULE_INFO("slim_waves", 0x1007, 0, 1);
STMOD_HANDLER previous = NULL;

int OnModuleStart(SceModule2 *mod)
{
	if (strcmp(mod->modname, "sysconf_plugin_module") == 0)
	{
		_sw(_lw(mod->text_addr+0x5734), mod->text_addr+0x5730);
		_sw(0x24020001, mod->text_addr+0x5734);
		
		sceKernelDcacheWritebackAll();
		sceKernelIcacheClearAll();
	}

	if (!previous)
		return 0;
		
	return previous(mod);
}

int module_start(SceSize args, void *argp)
{
	previous = sctrlHENSetStartModuleHandler(OnModuleStart);
	return 0;
}