#include <pspsdk.h>
#include <pspkernel.h>
#include <systemctrl.h>
#include <string.h>

PSP_MODULE_INFO("slim_full", 0x1007, 0, 1);
STMOD_HANDLER previous = NULL;

int OnModuleStart(SceModule2 *mod)
{
	if (strcmp(mod->modname, "sceVshBridge_Driver") == 0)
	{
		u32 res = sctrlHENFindFunction("sceVshBridge_Driver", "sceVshBridge", 0xC6722C70);
		
		_sw(0x03E00008, res+0);
		_sw(0x24020001, res+4);
		
		sceKernelDcacheWritebackAll();
		sceKernelIcacheClearAll();
	}

	if (!previous)
		return 0;
		
	return previous(mod);
}

int module_start(SceSize args, void *argp)
{
	previous = sctrlHENSetStartModuleHandler(OnModuleStart);
	return 0;
}